//
//  OCTAppDelegate.m
//  ObjC-Test
//
//  Created by Felix Rohrer on 15.03.13.
//  Copyright (c) 2013 Felix Rohrer. All rights reserved.
//

#import "OCTAppDelegate.h"

#import "OCTViewController.h"
#import "TestData.h"

@implementation OCTAppDelegate

- (void)dealloc
{
    [_window release];
    [_viewController release];
    [super dealloc];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    self.window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];
    // Override point for customization after application launch.
    self.viewController = [[[OCTViewController alloc] initWithNibName:@"OCTViewController" bundle:nil] autorelease];
    self.window.rootViewController = self.viewController;
    [self.window makeKeyAndVisible];
    
    /*** Aufgabe 2 ***/
    if (NO) {
        while (YES) {
            TestData *testData = [[TestData alloc] init];
            [testData doThisRequiredThing]; // do nothing
            
            [NSThread sleepForTimeInterval:0.005];
        }
    }
    
    /*** Aufgabe 3 ***/
    if (NO) {
        while (YES) {
            TestData *testData = [[TestData alloc] init];
            [testData release];
            
            [NSThread sleepForTimeInterval:0.005];
        }
    }
    
    
    /*** Aufgabe 4 ***/
    if (YES) {
        while (YES) {
            NSAutoreleasePool *myPool = [[NSAutoreleasePool alloc] init];
            for(int index = 0; index < 1000; index++) {
                TestData *testData = [[TestData alloc] init];
                [testData autorelease];
            
                [NSThread sleepForTimeInterval:0.005];
            }
            [myPool drain];
        }
    }
    
    /*** Aufgabe 5,6,7 ***/
    //[self doSelectorTesting];
    
    
    return YES;
}

-(void) doSelectorTesting {
    NSString *testString = @"Hello";
    TestData *testData = [[TestData alloc] init];
    
    
    [self testSelector:@"foo" onObject:testString];
    [self testSelector:@"doThisRequiredThing" onObject:testString];
    [self testSelector:@"myNewStringMethod" onObject:testString];
    [self testSelector:@"addSubview" onObject:testString];
    
    [self testSelector:@"foo" onObject:testData];
    [self testSelector:@"doThisRequiredThing" onObject:testData];
    [self testSelector:@"myNewStringMethod" onObject:testData];
    [self testSelector:@"addSubview" onObject:testData];
    
    
    [self testSelector:@"foo" onObject:self.viewController.view];
    [self testSelector:@"doThisRequiredThing" onObject:self.viewController.view];
    [self testSelector:@"myNewStringMethod" onObject:self.viewController.view];
    [self testSelector:@"addSubview" onObject:self.viewController.view];
    
}

-(void) testSelector:(NSString*)selectorName onObject:(id<NSObject>)object {
    SEL testSelector = NSSelectorFromString(selectorName);
    
    if ([object respondsToSelector:testSelector])
    {
        NSLog(@"'%@' does understand '%@'", NSStringFromClass([object class]), selectorName);
    }
    else
    {
        NSLog(@"'%@' does NOT understand '%@'", NSStringFromClass([object class]), selectorName);
    }
}



- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
